// Andrei Grigorean
// O(N)
// 100 pct

#include <cassert>
#include <cstring>

#include <deque>
#include <fstream>
#include <string>
using namespace std;

#define FORIT(it, v) for (typeof((v).begin()) it = (v).begin(); it != (v).end(); ++it)

typedef long long int64;

ifstream fin("lru.in");
ofstream fout("lru.out");

const int MAX_N = 1000000;
const int MAX_TESTS = 5;
const int SIGMA = 3;

int n;
string initial, final;
int A[MAX_N + 1];
int B[MAX_N + 1];

int p[SIGMA];
int removed[SIGMA];

void read() {
    fin >> n;
    assert(1 <= n && n <= MAX_N);

    fin >> initial;
    assert(static_cast<int>(initial.length()) == n);
    FORIT(it, initial)
        assert(*it == 'L' || *it == 'R' || *it == 'U');

    fin >> final;
    assert(static_cast<int>(final.length()) == n);
    FORIT(it, final)
        assert(*it == 'L' || *it == 'R' || *it == 'U');
}

inline int type(char ch) {
    switch (ch) {
        case 'L': return 0;
        case 'R': return 1;
        case 'U': return 2;
    }
    return -1;
}

void solve() {
    // transform string in arrays
    for (int i = 0; i < n; ++i) {
        A[i + 1] = type(initial[i]);
        B[i + 1] = type(final[i]);
    }

    int64 sol = 0;
    int destroyed = 0;

    // move pointers to last appearance
    for (int j = 0; j < SIGMA; ++j) {
        p[j] = n;
        while (p[j] > 0 && A[p[j]] != j)
            --p[j];
    }

    for (int i = n; i > 0; --i) {
        if (p[B[i]] <= destroyed) {
            sol += i;
            for (int j = 0; j < SIGMA; ++j) if (B[i] != j)
                ++removed[j];

            while (A[destroyed + 1] == 3) ++destroyed;
            ++destroyed;
        } else {
            sol += i - (p[B[i]] - removed[B[i]]);
            
            // mark removed elemenet
            A[p[B[i]]] = 3;

            for (int j = 0; j < SIGMA; ++j) if (B[i] != j)
                if (p[j] > p[B[i]])
                    ++removed[j];

            --p[B[i]];
            while (p[B[i]] > destroyed && A[p[B[i]]] != B[i]) {
                if (p[A[p[B[i]]]] < p[B[i]])
                    --removed[B[i]];
                --p[B[i]];
            }
        }
    }

    fout << sol << "\n";
}

void clear() {
    for (int i = 0; i < SIGMA; ++i)
        removed[i] = 0;
}

int main() {
    int tests;
    fin >> tests;
    assert(1 <= tests && tests <= MAX_TESTS);

    for (int test = 1; test <= tests; ++test) {
        clear();
        read();
        solve();
    }
}
