// Andrei Grigorean
// 20 pct

#include <cassert>

#include <fstream>
#include <string>
using namespace std;

#define FORIT(it, v) for (typeof((v).begin()) it = (v).begin(); it != (v).end(); ++it)

ifstream fin("lru.in");
ofstream fout("lru.out");

const int MAX_N = 1000000;
const int MAX_TESTS = 5;

int n;
string initial, final;
int move_cnt;

void read() {
    fin >> n;
    assert(1 <= n && n <= MAX_N);

    fin >> initial;
    assert(static_cast<int>(initial.length()) == n);
    FORIT(it, initial)
        assert(*it == 'L' || *it == 'R' || *it == 'U');

    fin >> final;
    assert(static_cast<int>(final.length()) == n);
    FORIT(it, final)
        assert(*it == 'L' || *it == 'R' || *it == 'U');
}

void move(int idx, char target) {
    if (initial[idx] == target) return;

    // increment global no of moves
    ++move_cnt;

    if (idx > 0) {
        move(idx - 1, target);
        initial[idx - 1] = initial[idx];
    }
    initial[idx] = target;
}

void solve() {
    move_cnt = 0;
    for (int i = n - 1; i >= 0; --i)
        move(i, final[i]);
    fout << move_cnt << "\n";
}

int main() {
    int tests;
    fin >> tests;
    assert(1 <= tests && tests <= MAX_TESTS);

    for (int test = 1; test <= tests; ++test) {
        read();
        solve();
    }
}
