// Andrei Grigorean
// O(N log N)
// 70 pct

#include <cassert>
#include <cstring>

#include <deque>
#include <fstream>
#include <string>
using namespace std;

#define FORIT(it, v) for (typeof((v).begin()) it = (v).begin(); it != (v).end(); ++it)

typedef long long int64;

ifstream fin("lru.in");
ofstream fout("lru.out");

const int MAX_N = 1000000;
const int MAX_TESTS = 5;
const int SIGMA = 3;

int n;
string initial, final;
deque<int> pos[SIGMA];
int aib[MAX_N + 1];

void update(int pos, int val) {
    while (pos <= n) {
        aib[pos] += val;
        pos += pos & -pos;
    }
}

int query(int pos) {
    int ans = 0;
    while (pos) {
        ans += aib[pos];
        pos -= pos & -pos;
    }
    return ans;
}

void read() {
    fin >> n;
    assert(1 <= n && n <= MAX_N);

    fin >> initial;
    assert(static_cast<int>(initial.length()) == n);
    FORIT(it, initial)
        assert(*it == 'L' || *it == 'R' || *it == 'U');

    fin >> final;
    assert(static_cast<int>(final.length()) == n);
    FORIT(it, final)
        assert(*it == 'L' || *it == 'R' || *it == 'U');
}

inline int type(char ch) {
    switch (ch) {
        case 'L': return 0;
        case 'R': return 1;
        case 'U': return 2;
    }
    return -1;
}

void solve() {
    int64 sol = 0;

    for (int i = 0; i < n; ++i)
        pos[type(initial[i])].push_back(i + 1);

    for (int i = n; i > 0; --i) {
        int target = type(final[i - 1]);

        if (pos[target].empty()) {
            sol += i;
            update(1, 1);

            int last = n + 1, p = -1;
            for (int i = 0; i <= 2; ++i)
                if (!pos[i].empty()) {
                    int val = pos[i].front();
                    if (val < last) {
                        last = val;
                        p = i;
                    }
                }
            assert(p != -1);
            pos[p].pop_front();
        } else {
            int p = pos[target].back();
            pos[target].pop_back();

            sol += i - (p - query(p));
            update(p, 1);
        }
    }
    
    fout << sol << "\n";
}

void clear() {
    for (int i = 0; i < SIGMA; ++i)
        pos[i].clear();
    memset(aib, 0, sizeof(aib));
}

int main() {
    int tests;
    fin >> tests;
    assert(1 <= tests && tests <= MAX_TESTS);

    for (int test = 1; test <= tests; ++test) {
        clear();
        read();
        solve();
    }
}
